'' Heater Driver
'' Runs in its own COG

VAR

  long  Heater
  long  ZeroCross
  
  long  Level
  long  ControlVar
  long  COG
  long  Stack[10]

PUB Start (_Heater, _ZeroCross)

  Heater := _Heater
  ZeroCross := ZeroCross

  COG := cognew(PWM, @Stack)+1
  return COG

PUB Set(Value)

  ControlVar := Value
  
PRI PWM

  dira[Heater] := 0
  dira[Heater] := 1

  repeat
    repeat Level from 100 to 1
      waitpeq(1 << ZeroCross, 1 << ZeroCross, 0)                              ' wait for zero-cross      
      if (ControlVar => level)                                          ' on now?
        outa[Heater] := 0       
      waitcnt(cnt + (clkfreq / 500))                            ' 2ms delay      
      outa[Heater] := 1                                          ' kill triac output